### Method

# Gio DBusConnection call_with_unix_fd_list

since: 2.30

#### Declaration

    void
    g_dbus_connection_call_with_unix_fd_list (
      GDBusConnection* connection,
      const gchar* bus_name,
      const gchar* object_path,
      const gchar* interface_name,
      const gchar* method_name,
      GVariant* parameters,
      const GVariantType* reply_type,
      GDBusCallFlags flags,
      gint timeout_msec,
      GUnixFDList* fd_list,
      GCancellable* cancellable,
      GAsyncReadyCallback callback,
      gpointer user_data
    )

#### Description

Like `g_dbus_connection_call()` but also takes a `GUnixFDList` object.

The file descriptors normally correspond to `G_VARIANT_TYPE_HANDLE` values in the body of the message. For example, if a message contains two file descriptors, `fd_list` would have length 2, and `g_variant_new_handle (0)` and `g_variant_new_handle (1)` would appear somewhere in the body of the message (not necessarily in that order!) to represent the file descriptors at indexes 0 and 1 respectively.

When designing D-Bus APIs that are intended to be interoperable, please note that non-GDBus implementations of D-Bus can usually only access file descriptors if they are referenced in this way by a value of type `G_VARIANT_TYPE_HANDLE` in the body of the message.

This method is only available on UNIX.

Available since: 2.30

This method completes asynchronously. Use `g_dbus_connection_call_with_unix_fd_list_finish()` inside the `GAsyncReadyCallback` to obtain the result of the operation.

#### Parameters

`bus_name`

  Type: `const gchar*`

  A unique or well-known bus name or `NULL` if `connection` is not a message bus connection.

  The argument can be `NULL`.
  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`object_path`

  Type: `const gchar*`

  Path of remote object.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`interface_name`

  Type: `const gchar*`

  D-Bus interface to invoke method on.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`method_name`

  Type: `const gchar*`

  The name of the method to invoke.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`parameters`

  Type: `GVariant`

  A `GVariant` tuple with parameters for the method or `NULL` if not passing parameters.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`reply_type`

  Type: `GVariantType`

  The expected type of the reply, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`flags`

  Type: `GDBusCallFlags`

  Flags from the `GDBusCallFlags` enumeration.

`timeout_msec`

  Type: `gint`

  The timeout in milliseconds, -1 to use the default timeout or `G_MAXINT` for no timeout.

`fd_list`

  Type: `GUnixFDList`

  A `GUnixFDList` or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`cancellable`

  Type: `GCancellable`

  A `GCancellable` or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`callback`

  Type: `GAsyncReadyCallback`

  A `GAsyncReadyCallback` to call when the request is satisfied or `NULL` if you don’t * care about the result of the method invocation.

  The argument can be `NULL`.

`user_data`

  Type: `gpointer`

  The data to pass to `callback`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.